/// <reference types="node" />
import { URL } from 'url';
/**
 * Decodes a string into the `URL` type
 */
export declare const Url: Omit<import("..").Type<string, string>, "from" | "defaultValue"> & Omit<{
    displayName: string;
    description: string;
    from(str: string): Promise<URL>;
}, "from"> & import("../from").From<string, URL>;
/**
 * Decodes an http/https only URL
 */
export declare const HttpUrl: Omit<Omit<import("..").Type<string, string>, "from" | "defaultValue"> & Omit<{
    displayName: string;
    description: string;
    from(str: string): Promise<URL>;
}, "from"> & import("../from").From<string, URL>, "from" | "defaultValue"> & Omit<{
    from(url: URL): Promise<URL>;
}, "from"> & import("../from").From<string, URL>;
