/**
 * A small helper to easily use `process.argv` without dropping context
 *
 * @param cmd a command line parser
 */
export function binary(cmd) {
    return {
        ...cmd,
        run(context) {
            var _a;
            const name = cmd.name || context.nodes[1].raw;
            (_a = context.hotPath) === null || _a === void 0 ? void 0 : _a.push(name);
            context.nodes.splice(0, 1);
            context.nodes[0].raw = name;
            context.visitedNodes.add(context.nodes[0]);
            return cmd.run(context);
        },
    };
}
//# sourceMappingURL=binary.js.map